#include "imgui.h"

//Called from IOGfxDisplaySW/GL2
extern void dbg_imgui();
//Ran at start to update jukebox list
extern void jukelist();
extern void play_sneedle();
//For the debug log
extern ImGuiTextBuffer Buf, errBuf, dbgBuf, infBuf;
//For the tile toggle and info window
extern bool render_tiles, drawhard;
//For the pink squares, sprites, and mem info, and so on and so on *sniffs*
extern bool debug_meminfo, debug_pinksquares, debug_drawsprites, debug_drawgame, debug_gamewindow, debug_paused, debug_conpause, debug_infhp, debug_magcharge;
extern bool debug_invspri, debug_noclip, debug_vision, debug_screenlock, debug_badpic, debug_conwrite, debug_assratio, debug_walkoff;
extern int lbutton, debug_fontsize;
extern int midiplayer;
//Ini stuff
extern const char* dispfont;
extern char debugfon[200];
//TODO: get rid of most of the above
//This is the struct in which settings are stored
struct debugsettings {
    bool drawhard;
    bool dswitch;
    bool logwindow;
    int lbutton;
    bool debug_meminfo, debug_pinksquares, debug_drawsprites, debug_drawgame, debug_gamewindow, debug_paused, debug_conpause, debug_scripboot, debug_interp, debug_infhp, debug_magcharge;
    bool debug_invspri, debug_noclip, debug_vision, debug_screenlock, debug_badpic, debug_conwrite, debug_assratio, debug_walkoff;
    bool screentrans, debug_audiopos, debug_speechsynth, debug_returnint, debug_coltext, debug_warpfade, debug_goodshadows;
    bool devmode;
    int corner = 1;
    bool altfade = true;
    int musvol = 100;
    float sfxvol = 1.0;
    float speevol;
    bool audiodelay = true;
    bool jrumble = true;
    //for the colour shader
    bool shader_colour, shader_colcycle;
    float shader_r = 1.0f, shader_g = 1.0f, shader_b = 1.0f;
    bool ranksprites;
    bool alttext, framelimit, autosave;
    //for retaining settings using cereal
    template <class Archive>
    void serialize(Archive &ar) {
        ar(drawhard, dswitch, logwindow, lbutton, debug_meminfo, debug_pinksquares, debug_drawsprites, debug_drawgame, debug_gamewindow, debug_paused, debug_conpause, debug_scripboot, debug_interp, debug_infhp, debug_magcharge,
        debug_invspri, debug_noclip, debug_vision, debug_screenlock, debug_badpic, debug_conwrite, debug_assratio, debug_walkoff,
        screentrans, debug_audiopos, debug_speechsynth, debug_returnint, debug_coltext, debug_warpfade, debug_goodshadows, devmode, corner, altfade, musvol, sfxvol, speevol, audiodelay, jrumble,
        shader_colour, shader_colcycle, shader_r, shader_g, shader_b, ranksprites, alttext, framelimit, autosave);
    }
};

extern debugsettings dbg;